# exl.rb  (coding: Windows-31J)  2013/12/25
  # Copyright (C) T. Yoshiizumi, 2012-2013 All rights reserved.
require "erb"
require "stringio"
require "exlap"
require "yados"
require "rrxwin"
require "rrxutil"
require "wrdap"
require "kramdown"
require "nokogiri"

wsh = WIN32OLE.new("WScript.Shell")
sendto_dir = wsh.SpecialFolders("SendTo")
bat_file = "ExlRun.bat"
bat_fullpath = "#{sendto_dir}\\#{bat_file}"
exe_file = defined?(ExerbRuntime) ? ExerbRuntime.filepath :
    ENV['OCRA_EXECUTABLE']
base_dir = exe_file ? File.dirname(exe_file.gsub(/\\/, "/")) : "."
msg_file = Exl::fullpath( "#{base_dir}/exl_msg.txt" )
WIN32OLE.new("Scripting.FileSystemObject").Drives.each do |drv|
  next  unless "#{drv.DriveLetter}" == msg_file[0,1].upcase
  if !drv.IsReady or drv.FreeSpace < 100 or
      drv.DriveType == 0 or drv.DriveType == 4
    msg_file = nil
  end
end

zzfilename = zztemp = nil
if ARGV.size < 1
  if test(?e, bat_fullpath)
    File.unlink(bat_fullpath)
    wmsg = "remove '#{bat_file}' in SendTo folder.\n"
    wsh.Popup(wmsg, 0, "exl message")
    File.open(msg_file, "w") {|ff|  ff.puts wmsg}  if msg_file
  elsif exe_file
    bat_contents = "@echo off\nCD /D \"%~dp1\"\n" +
        "\"#{exe_file}\" \"%~f1\" >!stdout.txt 2>!stderr.txt\n" +
        "FOR %%I IN (!std*.txt) DO IF %%~zI EQU 0 DEL %%I\n"
    File.open(bat_fullpath, "w") {|ff|  ff.write bat_contents}
    bat_contents = nil
    wmsg = "create '#{bat_file}' in SendTo folder.\n"
    wsh.Popup(wmsg, 0, "exl message")
    File.open(msg_file, "w") {|ff|  ff.puts wmsg}  if msg_file
  else
    wmsg = "can't grasp the fullpath of 'exl.exe'."
    wsh.Popup(wmsg, 0, "exl message")
    File.open(msg_file, "w") {|ff|  ff.puts wmsg}  if msg_file
  end
elsif ARGV[0] =~ /^(\/|-)help$/i
  wmsg = "exl.exe: execute a ruby script with exlap.rb etc.\n" +
      "usage: exl.exe script [argv1 argv2 argv3 ...]\n"
  wsh.Popup(wmsg, 0, "exl message")
  File.open(msg_file, "w") {|ff|  ff.puts wmsg}  if msg_file
elsif ARGV[0] =~ /^(\/|-)rmzero$/i
  ARGV.shift
  ARGV.each {|x|  File.unlink(x)  if test(?z,x)}
elsif ARGV[0] =~ /^(\/|-)x$/
  ARGV.shift
  if ARGV.size > 0 and test(?f, ARGV[0]) and !test(?z, ARGV[0])
    fname = Exl::fullpath(ARGV.shift)
    body = File.open(fname) {|ff|  ff.read}
    if body =~ /^\#![^\n]*ruby/
      lines = body.split(/\n/)
      lines.each_with_index do |line, i|
        break  if line =~ /^\#!.*ruby/
        if i == 0
          if RUBY_VERSION.to_f >= 1.9
            etype = 'a'.encoding.to_s
            lines[i] = "# (coding: #{etype}) " + line
          else
            lines[i] = "# " + line
          end
        else
          lines[i] = "# " + line
        end
      end
      zztemp = Tempfile.new(['exl', '.rb'])
      zztemp.write lines.join("\n")+"\n"
      zztemp.close
      zzfilename = fname
      fname = body = lines = nil
    else
      zzfilename = fname
      fname = nil
    end
  elsif ARGV.size > 0
    wmsg = "can't find or use '#{ARGV[0]}' after '-x'"
    wsh.Popup(wmsg, 0, "exl message")
    File.open(msg_file, "w") {|ff|  ff.puts wmsg}  if msg_file
  end
else
  zzfilename = Exl::fullpath(ARGV.shift)
  if !test(?f, zzfilename) or test(?z, zzfilename)
    wmsg = "can't find or use '#{zzfilename}'\n"
    wsh.Popup(wmsg, 0, "exl message")
    File.open(msg_file, "w") {|ff|  ff.puts wmsg}  if msg_file
    zzfilename = nil
  end
end
wsh = sendto_dir = bat_file = bat_fullpath = exe_file = nil
if zzfilename
  zzbody = File.open(zzfilename) {|ff| ff.read}
  if zzbody =~ /\n__END__\n(.+)\Z/m
    zztail = $1
    DATA = StringIO.new(zzbody)
    DATA.pos = zzbody.bytesize - zztail.bytesize
  end
  zzstr = zzary = nil
  begin
    !zztemp ? load(zzfilename) : load(zztemp.path)
  rescue SyntaxError, RuntimeError, NameError, LoadError, StandardError
    zzstr = $!.to_s
    zzary = $@.dup
  end
  if zzstr and zzary
    orgname = zzfilename.gsub(/\\/, "/")
    path1 = path2 = nil
    if zztemp
      path1 = zztemp.path
      path2 = (path1 =~ /\//) ? path1.gsub(/\//, "\\") : path1.gsub(/\\/, "/")
      if zzstr[path1] then  zzstr[path1] = orgname \
      elsif zzstr[path2] then  zzstr[path2] = orgname  end
    end
    pstr = ''
    zzary.each {|x|
      if path1 and path2
        if x[path1] then  x[path1] = orgname \
        elsif x[path2] then  x[path2] = orgname  end
      end
      pstr += "#{x}\n"
    }
    wmsg = "#{zzstr}\n#{pstr}\n"
    STDERR.puts wmsg
    File.open(msg_file, "w") {|ff|  ff.puts wmsg}  if msg_file
  end
  zztemp.unlink  if zztemp
  $ExlapObject.quit  if $ExlapObject
end
exit
