# Wrdap.rb version 1.0 (coding: Windows-31J)  2013/02/16
  # an ruby library for Word OLE control
  # Copyright (C) T. Yoshiizumi, 2013 All rights reserved.
require "win32ole"

module WrdConstant
end

# ʂɗp郁\bh
module Wrd
  module_function()
  def fullpath(fname)
    fso = WIN32OLE.new('Scripting.FileSystemObject')
    return fso.GetAbsolutePathName(fname)
  end

  def filename2(fname)
    fname = fullpath(fname)
    dd = File.dirname(fname).gsub(/\//, "\\")
    unless dd =~ /\\$/
      dd = dd + "\\"
    end
    ff = File.basename(fname)
    return [dd, ff]
  end

  def filename3(fname)
    fname = fullpath(fname)
    dd = File.dirname(fname).gsub(/\//, "\\")
    unless dd =~ /\\$/
      dd = dd + "\\"
    end
    ff = File.basename(fname, ".*")
    ee = File.extname(fname)
    return [dd, ff, ee]
  end
end

# [h̃hLg߂̃NX
class Wrdoc
  include WrdConstant

    TypeExp = {1=>'Standard', 2=>'Class', 3=>'UserForm'}
    Fext = {1=>'.bas', 2=>'.cls', 3=>'.frm'}

  def initialize(wrd)
    @app = wrd
    @obj = @open_type = @filename = nil
  end
  attr_accessor :app
  attr_accessor :obj
  attr_accessor :open_type
  attr_accessor :filename

  def close
    @app.doc_close(self)
  end

  # t@C̊gq .doc ȂǂɂȂ悤
  def filename_arrange(fname)
    w = fname.gsub(/\\/, "/")
    e = File.extname(w)
    d = File.dirname(w)
    f = File.basename(w, ".*")
    if d != ""
      d = d.sub(/\/$/, "")
      d = d.gsub(/\//, "\\") + "\\"
    end
    res = d + f
    if @app.ext_type[e.downcase] != nil
      res = res + e
    else
      res = res + ".doc"
    end
    return res
  end

  def save(save_name = nil)
    return  unless @obj
    ext_type = @app.ext_type
    da_v = @app.display_alert(false)
    error_msg = nil
    if save_name == nil
      if @open_type == 'OPEN'
        ffmt = ext_type[File.extname(@filename).downcase]
        if ffmt
          begin
            @obj.SaveAs({'FileName'=>@filename, 'FileFormat'=>ffmt})
          rescue
            error_msg = $!
          end
        else
          begin
            @obj.Save  # ㏑ۑ
          rescue
            error_msg = $!
          end
        end
      else
        outfile = filename_arrange(@filename)
        ffmt = ext_type[File.extname(outfile).downcase]
        begin
          @obj.SaveAs({'FileName'=>outfile, 'FileFormat'=>ffmt})
        rescue
          error_msg = $!
        end
      end
    else  # save_namew肳ꂽꍇ
      outfile = Wrd::fullpath(save_name)
      ffmt = ext_type[File.extname(outfile).downcase]
      unless ffmt
        outfile = filename_arrange(outfile)
        ffmt = ext_type[File.extname(outfile).downcase]
      end
      begin
        @obj.SaveAs({'FileName'=>outfile, 'FileFormat'=>ffmt})
      rescue
        error_msg = $!
      end
    end
    @app.display_alert(da_v)
    if error_msg
      svname = !save_name ? self.name : save_name
      STDERR.printf("Wrdoc.save: can't save '%s'\n%s\n\n", svname, error_msg)
    end
  end

  def name  # hLg̖O(tpXłȂEgq܂)Ԃ
    return  File.basename(@filename)
  end

  def each(&block)
    return  unless block
    self.sheet_names.each {|sn|
      block.call(self.select_sheet(sn))
    }
  end

  def macro_code(type=nil, name=nil)  # componentsource code擾
    str = ''
    @obj.VBProject.VBComponents.each do |component|
      next  if ![1,2,3].include?(component.Type) or
          type and component.Type != type or name and component.Name != name
      str += "' <<type:#{TypeExp[component.Type]},  name:#{component.Name}>>\n"
      cnt = component.CodeModule.CountOfLines
      cstr = (cnt > 0) ? component.CodeModule.Lines(1, cnt) :
          "' ---- empty ----"
      str += "#{cstr}\n\n"
      break  if type and name
    end
    return str.gsub(/\r\n/, "\n")
  end

  def macro_add(str, type=nil, name=nil)  # componentǉ
    str = (str.class != String or str =~ /\A\s*\Z/) ? nil : str.dup
    fname = nil
    if str and str !~ /\r|\n/ and
          test(?e, Wrd::fullpath(str))
      fname = Wrd::fullpath(str)
    end
    type = 1  unless type
    component = @obj.VBProject.VBComponents.Add(type)
    if name
      begin
        component.Name = name
      rescue
        STDERR.printf("Wrdoc.macro_add: can't be named as '%s'\n\n", name)
      end
    end
    if str
      str = str.gsub(/\' <<type\:[A-Za-z]+, +name\:.+?>>\n/, "")
      str = str.gsub(/' ---- empty ----\n/, "")
      !fname ? component.CodeModule.AddFromString(str) :
          component.CodeModule.AddFromFile(fname)
    end
    return component
  end

  def macro_export(type=nil, name=nil, opt=nil)  # componentfileƂďo
    len = self.name.length
    path = @filename[0...-len]
    msg = {}
    res = []
    @obj.VBProject.VBComponents.each do |component|
      next  if ![1,2,3].include?(component.Type) or
          type and component.Type != type or name and component.Name != name
      fname = !opt ? "#{path}#{component.Name}#{Fext[component.Type]}" :
          "#{path}#{self.name}!#{component.Name}#{Fext[component.Type]}"
      begin
        component.Export(fname)
      rescue
        msg[fname] = $!
      end
      res << [component.Type, component.Name]  if !msg[fname]
    end
    msg.each do |fname, str|
      STDERR.printf("Wrdoc.macro_export: fails to export '%s'\n%s\n\n",
          File.basename(fname), str)
    end
    return res
  end

  def macro_import(filename, dup_check=false)  # componentfile擾
    res = nil
    filename = Wrd::fullpath(filename)
    unless test(?e, filename)
      return res
    end
    bodyname = File.basename(filename, ".*")
    msg = nil
    exist_flag = false
    if dup_check
      @obj.VBProject.VBComponents.each do |component|
        next  unless [1,2,3].include?(component.Type)
        if bodyname.casecmp(component.Name) == 0
          msg = sprintf("Wrdoc.macro_import: '%s' has already existed " +
              "in '%s'.\n\n", component.Name, @obj.Name)
          exist_flag = true
          break
        end
      end
    end
    if !dup_check or !exist_flag
      begin
        component = @obj.VBProject.VBComponents.Import(filename)
      rescue
        component = nil
        msg = sprintf("Wrdoc.macro_import: error!\n%s\n\n", $!)
      end
      res = [component.Type, component.Name]  if component
    end
    if msg
      STDERR.print msg
    end
    return res
  end

  def macro_remove(type=nil, name=nil)  # component폜
    res = []
    project = @obj.VBProject
    project.VBComponents.each do |component|
      next  if ![1,2,3].include?(component.Type) or
          type and component.Type != type or name and component.Name != name
      tn = [component.Type, component.Name]
      begin
        project.VBComponents.Remove(component)
      rescue
        tn = nil
      end
      res << tn  if tn
      break  if type and name
    end
    return res
  end

  def macro_list(type=nil, name=nil)  # componentType, Namȇg݂zŕԂ
    res = []
    @obj.VBProject.VBComponents.each do |component|
      next  if ![1,2,3].include?(component.Type) or
          type and component.Type != type or name and component.Name != name
      res << [component.Type, component.Name]
      break  if type and name
    end
    return res
  end

  def macro_list2(type=nil, name=nil)  # component objectzŕԂ
    res = []
    @obj.VBProject.VBComponents.each do |component|
      next  if ![1,2,3].include?(component.Type) or
          type and component.Type != type or name and component.Name != name
      res << component
      break  if type and name
    end
    return res
  end

  def macro_run(mname, *arg)  # }Ns
    cmd = "'#{@obj.Name}'!#{mname}"
    msg = nil
    res = nil
    begin
      if arg.size == 0
        res = @app.obj.Run cmd
      else
        res = @app.obj.Run(cmd, *arg)
      end
    rescue
      msg = sprintf("Wrdoc.macro_run: error!\n%s\n\n", $!)
      res = nil
    end
    if msg
      STDERR.print msg
    end
    return res
  end
  alias :run :macro_run

  def macro_name(type=nil, name=nil)  # componentprocedure nameꗗ
    res = {}
    @obj.VBProject.VBComponents.each do |component|
      next  if ![1,2,3].include?(component.Type) or
          type and component.Type != type or name and component.Name != name
      proc_names = []
      ccm = component.CodeModule
      cnt = ccm.CountOfLines
      for i in 1..cnt
        pn = ccm.ProcOfLine(i,0)
        if pn.class == String  and pn != "" and !proc_names.include?(pn)
          proc_names << pn
        end
      end
      res[[component.Type, component.Name]] = proc_names
      break  if type and name
    end
    return res
  end

  def method_missing(sym, *arg)
    name = sym.to_s
    if name =~ /^[A-Z_]/
      return @obj.send(sym, *arg)
    else
      STDERR.puts "undefined method `#{name}' for Wrdoc (NameError)"
    end
  end
end

# Word Application߂̃NX
class Wrdap
  include WrdConstant

  def init_set()
    @obj = @word_version = @ext_type = nil
    @order = @last = nil
    @auto_quit = false
    @auto_close = false
    @docs = []
    begin
      @obj = WIN32OLE.new('Word.Application')
    rescue
      @obj = nil
    end
    if @obj
      @obj.Visible = true
      unless defined?(WrdConstant::CONSTANTS)
        wv = $VERBOSE
        $VERBOSE = nil
        WIN32OLE.const_load(@obj, WrdConstant)
        $VERBOSE = wv
      end
      @word_version = @obj.Version.to_f
      if @word_version >= 12.0
        @ext_type = {".doc"=>WdFormatDocument, ".rtf"=>WdFormatRTF,
            ".htm"=>WdFormatHTML, ".html"=>WdFormatHTML, ".txt"=>WdFormatText,
            ".docx"=>WdFormatXMLDocument,
            ".docm"=>WdFormatXMLDocumentMacroEnabled,
            ".odt"=>WdFormatOpenDocumentText,
            ".xml"=>WdFormatXML}
      else
        @ext_type = {".doc"=>WdFormatDocument, ".rtf"=>WdFormatRTF,
            ".htm"=>WdFormatHTML, ".html"=>WdFormatHTML, ".txt"=>WdFormatText}
        if defined?(WdFormatXML)
          @ext_type[".xml"] = WdFormatXML
        end
      end
    end
  end
  private :init_set
  attr_reader :obj
  attr_reader :word_version
  attr_reader :ext_type
  attr_reader :order
  attr_reader :last
  attr_accessor :auto_quit
  attr_accessor :auto_close

  def initialize(*fname, &block)
    init_set()
    $WrdapObject = self  if @obj
    if @obj and fname.size > 0
      @last = fname.size
      for n in 0...@last
        @order = n + 1
        doc = doc_open(fname[n])
        if block
          block.call(doc)
          doc_close(doc)  if @auto_close
        end
      end
      @order = @last = nil
      self.quit  if block
    end
  end

  def quit
    if @obj
      display_alert(false)
      if @obj.Documents.Count > 0
        @obj.Documents.each {|d|  d.Close}
      end
      @obj.Quit
      @docs = []
      @obj = @word_version = @ext_type = nil
      @order = @last = nil
      $WrdapObject = nil
    end
  end

  def opens(*fname, &block)
    res = []
    if @obj and fname.size > 0
      @last = fname.size
      for n in 0...@last
        @order = n + 1
        doc = doc_open(fname[n])
        if block
          block.call(doc)
          doc_close(doc)  if @auto_close
        else
          res << doc
        end
      end
      @order = @last = nil
      self.quit  if block and @auto_quit
    end
    if res.size < 1
      res = nil
    end
    return res
  end

  def opens_once(*fname, &block)
    unless block
      return
    end
    res = []
    if @obj and fname.size > 0
      for n in 0...fname.size
        doc = doc_open(fname[n])
        res << doc
      end
    end
    if res.size > 0
      block.call(*res)
      if @auto_close
        res.each {|doc|
          doc_close(doc)
        }
      end
      self.quit  if @auto_quit
    end
  end

  def doc_open(param)
    doc = nil
    fname = nil
    if param
      if param.class == String
        fname = param.dup
        param = Hash.new
      elsif param.class == Hash
        fname = param['Filename']
      else
        param = nil
      end
    end
    if @obj and param and fname
      fname = Wrd::fullpath(fname)
      param['Filename'] = fname
      doc = select_doc(fname)
      unless doc  # ܂JĂȂhLgł
        doc = Wrdoc.new(self)
        if test(?e, fname)  # ̃t@CI[v
          display_alert(false) do
            doc.obj = @obj.Documents.Open(param)
            doc.open_type = 'OPEN'
          end
        else  # ݂Ȃt@CȂVK쐬
          doc.obj = @obj.Documents.Add()
          doc.open_type = 'ADD'
        end
        doc.filename = fname
      end
      if doc
        @docs << doc
      end
    end
    return doc
  end

  def doc_close(doc)
    if doc
      if doc.obj
        da_v = self.display_alert(false)
        doc.obj.Close
        self.display_alert(da_v)
      end
      doc.app = doc.obj = doc.open_type = doc.filename = nil
      @docs.delete(doc)
    end
  end

  def select_doc(fname)  # tpXfnameƏƍhLgI
    doc = nil
    @docs.each {|d|
      if d.filename.casecmp(fname) == 0
        doc = d
        break
      end
    }
    return doc
  end
  private :select_doc

  def select_doc(target)
    doc = nil
    if target.class == String
      @docs.each {|d|
        if d.name.casecmp(target) == 0
          doc = d
          break
        end
      }
    elsif [Fixnum,Bignum].include?(target.class)
      count = 0
      @docs.each {|d|
        count += 1
        if count == target
          doc = d
          break
        end
      }
    end
    return doc
  end

  def doc_names
    res = []
    @docs.each {|b|
      res << b.name
    }
    return res
  end

  def display_alert(val, &block)
    before_val = @obj.DisplayAlerts
    @obj.DisplayAlerts = val
    if block
      block.call()
      @obj.DisplayAlerts = before_val
      return
    end
    return before_val
  end

  def each(&block)
    return  unless block
    @last = @docs.size
    @order = 0
    @docs.each {|doc|
      @order += 1
      block.call(doc)
    }
    @order = @last = nil
  end

  def version  # Wrdap̃o[W
    return 1.0
  end

  def addin_list(regex = nil)
    ary = []
    @obj.AddIns.each do |target|
      if regex.class != Regexp or regex =~ target.Name
        ary << [target.Name, target.FullName]
      end
    end
    return ary
  end
  def method_missing(sym, *arg)
    name = sym.to_s
    if name =~ /^[A-Z_]/
      return @obj.send(sym, *arg)
    else
      STDERR.puts "undefined method `#{name}' for Wrdoc (NameError)"
    end
  end
end

include WrdConstant
