# yado.rb  version 1.62  (coding: Windows-31J) 2013/03/30
  # ruby library for handling of mdb,accdb,xls etc. through ADO | ADOX
  # Copyright (C) T. Yoshiizumi, 2008-2013 All rights reserved.
require 'win32ole'
require 'csv'
require "nkf"

# global variables
  # ADOڑp
  $YadoCns = Hash.new
  $YadoCns[:mdb] = "Provider=Microsoft.Jet.OLEDB.4.0;" +
      "Data Source=%dbname%;" +
      "User ID=%user%;Jet OLEDB:Database Password=%password%;"
  $YadoCns[:accdb] = "Provider=Microsoft.ACE.OLEDB.12.0;" +
      "Data Source=%dbname%;" +
      "User ID=%user%;Jet OLEDB:Database Password=%password%;"
  $YadoCns[:xls] = "Provider=Microsoft.Jet.OLEDB.4.0;" +
      "Data Source=%dbname%;" +
      "User ID=%user%;Jet OLEDB:Database Password=%password%;" +
      "Extended Properties=\"Excel 8.0;HDR=%hdr%;\""
  $YadoCns[:xlsx] = "Provider=Microsoft.ACE.OLEDB.12.0;" +
        "Data Source=%dbname%;" +
        "User ID=%user%;Jet OLEDB:Database Password=%password%;" +
        "Extended Properties=\"Excel 12.0 XML;HDR=%hdr%;\""
  # ̑̕ϐ
  $YadoCreateAdox = [:mdb, :accdb]  # VK쐬ADOXōs^Cv
  $YadoLocalType = [:mdb, :accdb, :xls, :xlsx]  # local file type
  $YadoTypeReplace = Hash.new  # ^CvϊpHash

# ̃NX⃂W[ŋʂɗp郁\bh
module YadoCommon
  ECNV = {'e'=>"e", 'euc-jp'=>"e", 's'=>"s", 'shift_jis'=>"s",
      'u'=>"w", 'utf-8'=>"w", 'windows-31j'=>"s"}

  module_function()
  def fread(filename, fmode="r")  # t@C̓e𕶎ŕԂ
    if RUBY_VERSION < "1.9"
      begin
        body = File.open(filename, fmode) {|ff|  ff.read}
      rescue
        body = ''
        STDERR.puts "can't open '#{filename}'"
      end
      if body != ''
        c = $KCODE.to_s.downcase[0,1]
        if fmode == "r" and c != "" and ECNV[c]
          c = ECNV[c]
          body = NKF.nkf("-m0#{c}", body)
        end
      end
    else
      fmode = "r:ASCII-8BIT"  if fmode == "r"
      begin
        body = File.open(filename, fmode) {|ff|  ff.read}
      rescue
        body = ''
        STDERR.puts "can't open '#{filename}'"
      end
      if body != ''
        unless fmode =~ /^rb/
          etype = 'a'.encoding.to_s  # XNvg̕R[h
          c = ECNV[etype.downcase]
          body = NKF.nkf("-m0#{c}", body)  if c != nil
          body.force_encoding(etype)
        end
      end
    end
    return body
  end

  def full_path(filename)  # w肳ꂽt@C΃pXŕԂ
    fso = WIN32OLE.new('Scripting.FileSystemObject')
    return fso.GetAbsolutePathName(filename)
  end

  def part_array(ary, elms)  # z񒆂̎wvfVzƂĕԂ
    r = []
    elms.each {|i|
      r << ary[i]
    }
    return r
  end

  NumClass = [Numeric, Integer, Fixnum, Bignum, Float]  # ruby̐lNX
  def same_array(aa, bb)  # ̔z̔r
    if aa == bb
      r = true
    elsif aa.size != bb.size
      r = false
    else  # vf͓
      r = true
      for i in 0...aa.size  # evf̔r
        anum = NumClass.include?(aa[i].class)
        bnum = NumClass.include?(bb[i].class)
        avalue = aa[i]
        bvalue = bb[i]
        if anum == true and bnum == false
          bvalue = bvalue.to_f  if bb[i].class == String
        elsif anum == false and bnum == true
          avalue = avalue.to_f  if aa[i].class == String
        elsif avalue.class == String and bvalue.class == String
          avalue = rm_both_space(avalue)
          bvalue = rm_both_space(bvalue)
          avalue = avalue.sub(/^(\d+\/\d+\/\d+) +00\:00\:00$/, "\\1")
          bvalue = bvalue.sub(/^(\d+\/\d+\/\d+) +00\:00\:00$/, "\\1")
          avalue = avalue.sub(/^(\d+)\/(\d+)\/(\d+)/) {|mp|
            mp = sprintf("%d/%d/%d", $1.to_i, $2.to_i, $3.to_i)}
          bvalue = bvalue.sub(/^(\d+)\/(\d+)\/(\d+)/) {|mp|
            mp = sprintf("%d/%d/%d", $1.to_i, $2.to_i, $3.to_i)}
        end
        if avalue != bvalue
          r = false
          break
        end
      end
    end
    return r
  end

  def create_xls(forc, tblname, flds, fldnames, datas)  # xls|xlsx쐬
    if forc.class == String  # forc̓t@C
      filename = full_path(forc)
      if filename =~ /\.xlsx$/i
        conn_str = "Provider=Microsoft.ACE.OLEDB.12.0;" +
            "Data Source=#{filename};" +
            "Extended Properties=\"Excel 12.0 XML;HDR=Yes;\""
      else
        conn_str = "Provider=Microsoft.Jet.OLEDB.4.0;" +
            "Data Source=#{filename};" +
            "Extended Properties=\"Excel 8.0;HDR=Yes;\""
      end
      cn = WIN32OLE.new("ADODB.Connection")
      cn.Open conn_str
    else
      cn = forc
    end
    sql = "create table #{quote(tblname)} (#{flds.join(',')});"
    cn.Execute(sql)
    sql = "select * from #{quote(tblname)};"
    rs = WIN32OLE.new("ADODB.Recordset")
    rs.Open sql,cn,3,3
    for rec in datas
      rs.AddNew
      rec.each_index {|i|
        next  if fldnames[i] == nil or rec[i] == nil
        rs.Fields.Item(fldnames[i]).Value = rec[i]
      }
      rs.Update
    end
    rs.Close
    cn.Close  if forc.class == String
  end

  def rm_both_space(s)  # ̗[̋󔒂폜BȊO͂̂܂ܕԂ
    unless s.class == String  # łȂ΂̂܂ܕԂ
      return s
    end
    s = s.sub(/^([ \t]|@)+/, "")
    s = s.sub(/([ \t]|@)+$/, "")
  end

  def rm_unable_char(s)  # e[uAtB[hƂĎgps̕폜
    unless s.class == String  # łȂ΂̂܂ܕԂ
      return s
    end
    s = s.gsub(/[\"\'!\[\]\`]+/, "")  # gps폜
    s = s.sub(/\.$/, "")
  end

  def quote(x)  # SQLLqł̃e[ubtB[h̖O̒EMSЎdl
    if !x  # wȂ
      r = '*'
    elsif x.class == String
      r = rm_both_space(x)
      r = rm_unable_char(r)
      if r =~ /[ -~]/
        r = "[#{r}]"
      end
    elsif x.class == Array  # tB[hQ
        r = x.map {|i|
          i = rm_both_space(i)
          i = rm_unable_char(i)
          if i =~ /[ -~]/
            i = "[#{i}]"
          end
          i
        }.join(',')
    else
      r = x
    end
    return r
  end

  def rmquote(x)
    while x =~ /^\[(.+)\]$/
      x = $1
    end
    return x
  end

  def get_value(fld)  # ̃tB[h̒loBoCiɂΉ
    if fld.Value.class == Array  # oCi^
      return fld.Value.pack("C*")
    else  # oCił͂Ȃ
      return fld.Value
    end
  end
end


# uCSV | ^u؂eLXgvruby̔z̑ݕϊW[
module YadoCsvTab
  include YadoCommon

  def csv_to_array(body)
    ary = CSV.parse(body)
    ary.map! {|row|
      row.map! {|x|
        x = x.to_s
        if x =~ /^\s*$/
          x = nil
        end
        x
      }
      row.pop  while row.size>0 and row.last==nil
      row
    }
    return ary
  end

  def array_to_csv(aa)
    str = ''
    aa.map! {|row|
      row = [row]  if row.class != Array
      row.map! {|x|
        if x.to_s =~ /^\s*$/
          x = nil
        end
        x
      }
    }
    aa.each {|row|
      line = CSV.generate_line(row)
      line.chomp!
      str += "#{line}\n"
    }
    return str
  end

  def tab_to_array(body)
    ary = (RUBY_VERSION < "1.9") ? CSV.parse(body, "\t") :
        CSV.parse(body, {:col_sep=>"\t"})
    ary.map! {|row|
      row.map! {|x|
        x = x.to_s
        if x =~ /^\s*$/
          x = nil
        end
        x
      }
      row.pop  while row.size>0 and row.last==nil
      row
    }
    return ary
  end

  def array_to_tab(aa)
    str = ''
    aa.map! {|row|
      row = [row]  if row.class != Array
      row.map! {|x|
        if x.to_s =~ /^\s*$/
          x = nil
        end
        x
      }
    }
    aa.each {|row|
      line = (RUBY_VERSION < "1.9") ? CSV.generate_line(row, "\t") :
          CSV.generate_line(row, {:col_sep=>"\t"})
      line.chomp!
      str += "#{line}\n"
    }
    return str
  end

  def table_turn(aa)  # Qz̍sƗ(cƉ)t]
    unless aa.class == Array
      return false
    end
    if aa[0].class != Array
      aa = [aa]
    end
    i_size = aa.size-1
    j_size = 0
    for i in 0..i_size
      next  unless aa[i].class == Array
      if (aa[i].size-1) > j_size
        j_size = aa[i].size-1
      end
    end
    if j_size == 0
      return false
    end
    r = []
    for j in 0..j_size
      w = []
      for i in 0..i_size
        if aa[i][j]
          w << aa[i][j]
        else
          w << ''
        end
      end
      r << w
    end
    return r
  end

  def print_array(filename, ary)  # zw̃t@Cɏo
    if !ary or ary.size == 0
      return
    end
    outfile = (File.open(filename, "w")  rescue  STDOUT)
    if filename =~ /\.csv$/i
      outfile.print(array_to_csv(ary))
    else
      outfile.print(array_to_tab(ary))
    end
    outfile.close  unless outfile == STDOUT
  end

  def scan_array(filename)  # w̃t@Cz荞
    if filename =~ /\.csv/i
      r = csv_to_array(fread(filename))
    else
      r = tab_to_array(fread(filename))
    end
    return r
  end
end    # YadoCsvTab ܂


# OLEIuWFNgꂽt@C琶̃oCi𒊏o
module YadoBin
  # BMPt@Cwb_\̂Ɋւ`
  Bitmap_file_header_form = "SLSSL"  # unpackpev[g
  SIZE_OF_FILE_HEADER = 14
  Bitmap_file_header_s = Struct.new(
      :Type,  # t@C^Cv  2 byte unsigned
      :Size,  # t@CTCY(oCg)  4 byte unsigned
      :Reserved1,  # U[u  2 byte unsigned
      :Reserved2,  # U[u  2 byte unsigned
      :OffBits)  # C[W܂ł̃ItZbg  4 byte unsigned
  # BMPwb_\̂Ɋւ`
  Bitmap_info_header_form = "LllSSLLllLL"  # unpackpev[g
  SIZE_OF_INFO_HEADER = 40
  Bitmap_info_header_s = Struct.new(
      :Size,  # \̂̃TCY  4 byte unsigned
      :Width,  # C[W̕  4 byte
      :Height,  # C[W̍  4 byte
      :Planes,  # must  2 byte unsigned
      :BitCount,  # FsNZ̃rbg  2 byte unsigned
      :Compression,  # k^Cv  4 byte unsigned
      :SizeImage,  # C[W̃TCY  4 byte unsigned
      :XPixPerMeter,  # 𑜓x  4 byte
      :YPixPerMeter,  # 𑜓x  4 byte
      :ClrUsed,  # J[e[u֌W  4 byte unsigned
      :ClrImporant)  # J[e[u֌W  4 byte unsigned
  # wb_̑݃`FbNs
  Header_check_len = 256  # wb_`FbNɏ\ȒƎv

  def adjust_four(x)  # SŊ؂悤ɂ؂グ
    return  (Integer((x-1) / 4 + 1) * 4)
  end
  private :adjust_four

  def get_native_bmp(body)  # OLEIuWFNgbody{BMPt@C𒊏o
    body_len = body.length
    check_len = Header_check_len
    if check_len > (body_len - SIZE_OF_INFO_HEADER)
      check_len = body_len - SIZE_OF_INFO_HEADER
    end
    if check_len <= (SIZE_OF_FILE_HEADER + SIZE_OF_INFO_HEADER)
      return nil
    end

    bfhs = Bitmap_file_header_s.new(0,0,0,0,0)
    bihs = Bitmap_info_header_s.new(0,0,0,0,0,0,0,0,0,0,0)
    start_pos = 0

    i = 0
    while i < check_len
      break if bfhs.Type == 0x4d42  and  bihs.Size == SIZE_OF_INFO_HEADER
      if bfhs.Type != 0x4d42
        ary = body[i...i+SIZE_OF_FILE_HEADER].unpack(Bitmap_file_header_form)
        if ary[0] == 0x4d42 and ary[1] > 0
          for j in 0...ary.size
            bfhs[j] = ary[j]
          end
          start_pos = i
          i += SIZE_OF_FILE_HEADER
          next
        end
      end

      if bihs.Size != SIZE_OF_INFO_HEADER
        ary = body[i...i+SIZE_OF_INFO_HEADER].unpack(Bitmap_info_header_form)
        if ary[0] == SIZE_OF_INFO_HEADER and  # TCY̒lÓ
           [1,4,8,24].include?(ary[4])  # F̒lÓ
          for j in 0...ary.size
            bihs[j] = ary[j]
          end
          i += SIZE_OF_INFO_HEADER
          next
        end
      end
      i += 1
    end

    if bfhs.Type == 0x4d42  and  bihs.Size == SIZE_OF_INFO_HEADER
        image_len = bihs.SizeImage  # BMP{̂̑傫
        if image_len == 0
          w = Integer((bihs.Width * bihs.BitCount) / 8)
          image_len = adjust_four(w) * bihs.Height
        end
        total_len = adjust_four(bfhs.OffBits + image_len) # ǂނׂTCY
        if total_len < bfhs.Size
          total_len = bfhs.Size
        end
        last_pos = start_pos + total_len - 1
        if last_pos > (body_len - 1)
          last_pos = body_len - 1
        end
        return body[start_pos..last_pos]
    else
      return nil
    end
  end
end

# e[uAtB[hACfbNX\ꂼ̍\̂̒`
  Table_s = Struct.new(:Name, :Type, :DateCreated, :DateModified)
  Field_s = Struct.new(:Name, :Type, :DefinedSize, :Precision,
      :NumericScale, :Attributes, :Properties)
  FldProperties_s = Struct.new(:Autoincrement, :Default, :Description,
      :Nullable, :"Fixed Length", :Seed, :Increment,
      :"Jet OLEDB:Column Validation Text",
      :"Jet OLEDB:Column Validation Rule",
      :"Jet OLEDB:IISAM Not Last Column",
      :"Jet OLEDB:AutoGenerate",
      :"Jet OLEDB:One BLOB per Page",
      :"Jet OLEDB:Compressed UNICODE Strings",
      :"Jet OLEDB:Allow Zero Length",
      :"Jet OLEDB:Hyperlink")
  Indexes_s = Struct.new(:Name, :PrimaryKey, :Unique, :IndexNulls,
      :Columns)
  IdxColumns_s = Struct.new(:Name, :SortOrder)

# MSЂ̃tB[h`߂̒萔ƃ\bh
module YadoMsDef
  # f[^^́uMS萔AASQLw薼v̑Ή\
  FIELD_type = [
    ["", "", ""], ["", "", ""],
    ["adSmallInt", "tE+-Rȓ", "smallint"],  # 2
    ["adInteger", "tE+-21ȓ", "integer"],  # 3
    ["adSingle", "Px_", "real"],  # 4
    ["adDouble", "{x_", "float"],  # 5
    ["adCurrency", "ʉ", "money"],  # 6
    ["adDate", "t^", "date"],  # 7
    ["adBSTR", "l", "VARCHAR"],  # 8
    ["adIDispatch", "COMIuWFNgIDispatchւ̃|C^", ""],  # 9
    ["adError", "32rbgG[R[h", ""],  # 10
    ["adBoolean", "Yes|No^", "bit"],  # 11
    ["adVariant", "I[g[VoAg^", ""],  # 12
    ["adIUnknown", "COMIuWFNgIUnknownC^[tFCXւ̃|C^", ""],  # 13
    ["adDecimal", "Œ萸xуXP[̐mȐl", "DECIMAL"],  # 14
    ["", "", ""],
    ["adTinyInt", "tE-128+127", "SMALLINT"],  # 16
    ["adUnsignedTinyInt", "ȂE0255", "tinyint"],  # 17
    ["adUnsignedSmallInt", "ȂEUȉ", "SMALLINT"],  # 18
    ["adUnsignedInt", "ȂE42ȉ", "INTEGER"],  # 19
    ["adBigInt", "tE", "INTEGER"],  # 20
    ["adUnsignedBigInt", "ȂE", "INTEGER"],  # 21
    ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""],
    ["adFileTime", "ԁE1601N11̎", "TIME"],  # 64
    ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""],
    ["adGUID", "ŗL̃O[oʎqGUID", "guid"],  # 72
    ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""],
    ["adBinary", "oCi", "BINARY"],  # 128
    ["adChar", "l", "CHAR"],  # 129
    ["adWChar", "Œ蒷EŒ255", "char"],  # 130
    ["adNumeric", "Œ萸xуXP[̐mȐl", "decimal"],  # 131
    ["adUserDefined", "[U[`ϐ", ""],  # 132
    ["adDBDate", "tEyyyymmdd", "DATE"],  # 133
    ["adDBTime", "Ehhmmss", "TIME"],  # 134
    ["adDBTimeStamp", "tEyyyymmddhhmmss{", "DATE"],  # 135
    ["adChapter", "qsZbg̍sʂ4oCg`v^l", ""],  # 136
    ["", "", ""],
    ["adPropVariant", "I[g[VPROPVARIANT", ""],  # 138
    ["adVarNumeric", "l", "FLOAT"],  # 139
    ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""], ["", "", ""],
    ["adVarChar", "l", "VARCHAR"],  # 200
    ["adLongVarChar", "", "TEXT"],  # 201
    ["adVarWChar", "ϒEŒ255", "varchar"],  # 202
    ["adLongVarWChar", "", "text"],  # 203
    ["adVarBinary", "oCi^EŒ510", "binary"],  # 204
    ["adLongVarBinary", "oCiEOLEIuWFNg^", "longbinary"]]  # 205
      # FIELD_typeQƂ鎞̗vfԍ
  YadoMS = 0   # MS`̃f[^^萔(adDateȂ)𓾂
  YadoEXP = 1  # f[^^̐(uŒ蒷vȂ)𓾂
  YadoSQL = 2  # f[^^sqlw薼(integer, char Ȃ)𓾂

    # f[^^ɊւMS̒萔Ƃ̐l̑Ή\
    FIELD_values = Hash['adBigInt', 20,
        'adBinary', 128,
        'adBoolean', 11,
        'adBSTR', 8,
        'adChapter', 136,
        'adChar', 129,
        'adCurrency', 6,
        'adDate', 7,
        'adDBDate', 133,
        'adDBTime', 134,
        'adDBTimeStamp', 135,
        'adDecimal', 14,
        'adDouble', 5,
        'adEmpty', 0,
        'adError', 10,
        'adFileTime', 64,
        'adGUID', 72,
        'adIDispatch', 9,
        'adInteger', 3,
        'adIUnknown', 13,
        'adLongVarBinary', 205,
        'adLongVarChar', 201,
        'adLongVarWChar', 203,
        'adNumeric', 131,
        'adPropVariant', 138,
        'adSingle', 4,
        'adSmallInt', 2,
        'adTinyInt', 16,
        'adUnsignedBigInt', 21,
        'adUnsignedInt', 19,
        'adUnsignedSmallInt', 18,
        'adUnsignedTinyInt', 17,
        'adUserDefined', 132,
        'adVarBinary', 204,
        'adVarChar', 200,
        'adVariant', 12,
        'adVarNumeric', 139,
        'adVarWChar', 202,
        'adWChar', 130]

    # f[^^oCi^Typel
    Binary_types = [128, 204, 205]
      # w𔺂f[^^
    WithLength_types = [128, 130, 202, 204]
      # Œ萸xl^
    Decimal_types = [14, 131]

  # e[u̎(table.Type 蓾l)
  TABLE_type = ['TABLE', 'VIEW', 'LINK', 'ACCESS TABLE',
      'PASS-THROUGH']

  def field_form_ms(fs)  # Field_s MS萔`ɂɕϊ
    r = []
    unless Decimal_types.include?(fs.Type)
      if WithLength_types.include?(fs.Type)  # w𔺂f[^^
        r = [rmquote(fs.Name), FIELD_type[fs.Type][YadoMS], fs.DefinedSize]
      elsif fs.Properties["Autoincrement"] == true
        r = [rmquote(fs.Name), FIELD_type[fs.Type][YadoMS],
            fs.Properties["Seed"], fs.Properties["Increment"]]
      else  # w𔺂Ȃf[^^
        r = [rmquote(fs.Name), FIELD_type[fs.Type][YadoMS]]
      end
    else  # decimal(20,4) Ȃǂ̏ꍇ
      r = [rmquote(fs.Name), FIELD_type[fs.Type][YadoMS],
        fs.Precision, fs.NumericScale]
    end
    opt = ''
    if fs.Properties["Nullable"] == false
      opt = 'NOT NULL'
    end
    if fs.Properties["Default"].to_s != ''
      opt = opt + '  '  if opt != ''
      opt = opt + sprintf("Default %s", fs.Properties["Default"])
    end
    r << opt  if opt != ''
    return r
  end

  def field_form_sql(fs)  # Field_s SQLw^̗vfɕϊ
    r = []
    sqlname = FIELD_type[fs.Type][YadoSQL]
    if sqlname == ''
      return field_form_ms(fs)
    end
    unless Decimal_types.include?(fs.Type)
      if WithLength_types.include?(fs.Type)  # w𔺂f[^^
        r = [rmquote(fs.Name), sprintf("%s(%d)", sqlname, fs.DefinedSize)]
      elsif fs.Properties["Autoincrement"] == true
        r = [rmquote(fs.Name), sprintf("%s(%d,%d)", 'counter',
            fs.Properties["Seed"], fs.Properties["Increment"])]
      else  # w𔺂Ȃf[^^
        r = [rmquote(fs.Name), sqlname]
      end
    else  # decimal(20,4) Ȃǂ̏ꍇ
      r = [rmquote(fs.Name), sprintf("%s(%d,%d)", sqlname,
        fs.Precision, fs.NumericScale)]
    end
    opt = ''
    if fs.Properties["Nullable"] == false
      opt = 'NOT NULL'
    end
    if fs.Properties["Default"].to_s != ''
      opt = opt + '  '  if opt != ''
      opt = opt + sprintf("Default %s", fs.Properties["Default"])
    end
    r << opt  if opt != ''
    return r
  end
end

# G[bZ[W߂̃NX
class Error
  def initialize
    @YadoErrors = []  # G[bZ[W𑍂ĂɋL^
    @YadoErrorOutput = 1  # G[bZ[W𒀎o
  end

  def stock(str)  # G[bZ[WL^
    str = str.to_s  unless str.class == String
    if str and str != ''
      str = str.gsub(/\n\n+/m, "\n")
      @YadoErrors << str.chomp
      STDERR.puts @YadoErrors.last + "\n"  if @YadoErrorOutput == 1
    end
  end

  def last  # ÕG[bZ[W
    return @YadoErrors.last
  end

  def all  # ~ςĂG[bZ[WS
    return @YadoErrors
  end

  def print(filename)  # ~ςĂG[bZ[W𑍂ăt@Cɏo
    if @YadoErrors.size > 0
      outfile = (File.open(filename, "w")  rescue  false)
      unless outfile == false
        count = 0
        @YadoErrors.each {|msg|
          count += 1
          outfile.printf("#%d\n%s\n\n", count, msg)
        }
        outfile.close
      end
    end
  end

  def switch(sw)  # G[bZ[W̕WG[o̓XCb`
    if sw == 0 or sw == 1
      @YadoErrorOutput = sw
    end
  end
end

# sqlsɓtB[hƃf[^̂ƂĈNX
class Result
  include YadoCsvTab
  include YadoCommon
  include YadoMsDef

  def initialize(sql=nil, fss=nil, data=nil)
    @sql = sql  # sꂽsql(String)
    if @sql
      @sql = @sql.sub(/\n+\Z/, "")
      @sql = @sql.sub(/\A\n+/, "")
    end
    @fields = fss  # \Field_s̔z
    @data = data  # f[^{̂L^Qz
    @current_field = 0
    @current_row = 0
    @eof = false
  end
  attr_accessor :eof

  def each_record(fldnames=nil, &block)
    if num_fields < 1 or num_rows < 1 or !block
      return
    end
    for i in 0...num_rows
      flds = []
      for j in 0...num_fields
        if fldnames and fldnames.include?(@fields[j].Name) != true
          next
        end
        flds << @data[i][j]
      end
      block.call(flds)
    end
  end
  alias :each :each_record

  def list_field_names(binary_sw = :INCLUDE)  # tB[hQԂ
    r = []
    if @fields
      @fields.each {|fs|
        if Binary_types.include?(fs.Type)  # oCi^̏
          unless binary_sw == :EXCEPT
            r << rmquote(fs.Name)
          end
        else  # oCi^ȊȌ
          unless binary_sw == :ONLY
            r << rmquote(fs.Name)
          end
        end
      }
    end
    return r
  end

  def print_all_values(filename)  # oCi[ȊO𑍂ďo
    if num_fields < 1 or num_rows < 1
      return
    end
    if filename =~ /\.xlsx?/i
      print_to_xls(filename)
      return
    end
    r = []
    fldnames = list_field_names(:EXCEPT)
    if fldnames.size > 0
      r << [@sql]  if @sql
      r << fldnames
      @data.each {|rs|
        w = []
        for i in 0...rs.size
          next  if Binary_types.include?(@fields[i].Type)  # oCi^
          w << rs[i]
        end
        r << w
      }
      print_array(filename, r)
    end
  end
  alias :pav :print_all_values

  def print_to_xls(filename, tblname=nil)  # oCi[ȊOxlsɏo
    if num_fields < 1 or num_rows < 1
      return
    end
    flds = []
    fldnames = list_field_names(:EXCEPT)
    unless tblname
      if @fields[0].Properties['BASETABLENAME']
        tblname = @fields[0].Properties['BASETABLENAME']
      else
        w = Time.now.strftime("%H%M%S")
        tblname = sprintf("Sheet_%s_%03d", w, rand(1000))
      end
    end
    @fields.each {|fs|
      next  unless fldnames.include?(fs.Name)
      next  if Binary_types.include?(fs.Type)
      a = field_form_sql(fs)  # a[0]:tB[hAa[1]:f[^^
      if a[1] =~ /counter/i  # I[gCNg^ integer 
        a[1] = 'integer'
      elsif a[1] =~ /\(.+\)/  # w͍폜
        a[1] = a[1].sub(/\(.+\)/, "")
      end
      flds << "#{quote(a[0])} #{a[1]}"  # tB[h Name, Type L^
    }
    if flds.size < 1
      return
    end
    datas = []
    each_record(fldnames) {|rs|
      datas << rs
    }
    create_xls(filename, tblname, flds, fldnames, datas)
  end
  alias :p2x :print_to_xls

  def free  # 
    @sql = @fields = @data = nil
    @current_field = @current_row = 0
    @eof = false
  end

  def rs_load(rs, binary_sw = :INCLUDE)  # R[hZbgǂݍ
    fss = []
    data = []
    if rs.Fields.Count > 0
      unless rs.EOF or rs.BOF
        rs.Fields.each do |fld|
          if Binary_types.include?(fld.Type)
            if binary_sw == :EXCEPT
              next
            end
          else
            if binary_sw == :ONLY
              next
            end
          end
          fs = Field_s.new(rmquote(fld.Name), fld.Type, fld.DefinedSize,
              fld.Precision, fld.NumericScale, fld.Attributes, {})
          fld.Properties.each {|pr|  fs.Properties[pr.Name]=pr.Value}
          fss << fs
        end
        until rs.EOF
          flds = []
          rs.Fields.each do |fld|
            if Binary_types.include?(fld.Type)
              if binary_sw == :EXCEPT
                next
              end
            else
              if binary_sw == :ONLY
                next
              end
            end
            flds << get_value(fld)
          end
          data << flds
          rs.MoveNext
        end
      end
    end
    if fss.size > 0 and data.size > 0
      @fields = fss
      @data = data
    end
  end

  def print_to_db(db, tblname=nil)  # Result̓edbtblnameɏo
    if num_fields < 1 or num_rows < 1
      db.error.stock 'Result: oׂ͂f[^܂.'
      return
    end
    if db.status != true
      db.error.stock 'Result: w̃f[^x[XI[vĂ܂.'
      return
    end
    unless tblname
      if @fields[0].Properties['BASETABLENAME']
        tblname = @fields[0].Properties['BASETABLENAME']
      else
        w = Time.now.strftime("%H%M%S")
        tblname = sprintf("table_%s_%03d", w, rand(1000))
      end
    end
    flds = Array.new
    @fields.each {|fs|
      a = field_form_sql(fs)  # a[0]:tB[hAa[1]:f[^^
      flds << "#{quote(a[0])} #{a[1]}"  # tB[h Name, Type L^
    }
    sql = "create table #{quote(tblname)} (#{flds.join(',')});"
    db.query(sql)
    db.addnew(tblname, @data)
  end
  alias :p2d :print_to_db

  def data_seek(n)
    @current_row = n
  end

  def fetch_field()
    if @current_field >= num_fields
      return nil
    end
    f = @fields[@current_field]
    @current_field += 1
    f
  end

  def fetch_fields()
    @fields
  end

  def fetch_field_direct(n)
    @fields[n]
  end

  def fetch_lengths()  # ڃR[h̊e̒zŕԂ
    @data ? @data[@current_row].map {|i| i ? i.to_s.length : 0} : []
  end

  def fetch_row()
    ret = nil
    if !@data or @current_row >= @data.length
      @eof = true
      return ret
    end
    ret = @data[@current_row]
    @current_row += 1
    return ret
  end

  def fetch_hash()
    row = fetch_row
    return if !row
    hash = {}
    @fields.each_index {|i|
      f = @fields[i].Name
      hash[f] = row[i]
    }
    return hash
  end

  def field_seek(n)
    @current_field = n
  end

  def field_tell()
    @current_field
  end

  def num_fields()
    @fields ? @fields.size : 0
  end

  def num_rows()
    @data ? @data.length : 0
  end

  def row_seek(n)
    @current_row = n
  end

  def row_tell()
    @current_row
  end

  def each_hash(&block)
    return  if !@data or !block
    for i in 0...@data.size
      rs = @data[i]
      hash = {}
      @fields.each_index {|j|
        f = @fields[j].Name
        hash[f] = rs[j]
      }
      block.call(hash)
    end
  end
end


# ADO | ADOX ߂̊{NX
class Yadobase
  include YadoCommon
  include YadoMsDef

  def initialize(*opt, &block)
    if !opt or opt.size == 0
      dbprm = nil
    elsif opt.size == 1
      dbprm = opt[0]
    elsif opt.size == 2 and opt[0].class == String and opt[1].class == Symbol
      dbprm = {'dbname'=>opt[0], 'dbtype'=>opt[1]}
    else
      dbprm = nil
    end
    if dbprm
      dbname, dbtype = get_dbname(dbprm)
      if dbname and dbtype
        if dbprm.class == Hash
          dbprm['dbname'] = dbname
          dbprm['dbtype'] = dbtype
        else
          dbprm = {'dbname'=>dbname, 'dbtype'=>dbtype}
        end
      else
        dbprm = nil
      end
    end
    @dbname = @dbtype = @conn_str = @current_conn = nil
    @error = Error::new
    if dbprm
      if create_db(dbprm) == :LOSE
        @error.stock "create_db: '#{dbprm['dbname']}' n܂."
      else
        open_db(dbprm)
      end
    end
    if self.status() and block
      block.call(self)
      self.close_db
    end
  end
  attr_reader :error

  def status  # f[^x[XɐڑĂ邩ۂ
    return @current_conn ? true : false
  end

  def db_name()  # f[^x[X̖O
    return @dbname
  end

  def db_type()  # f[^x[X̃^Cv
    return @dbtype
  end

  def create_db(dbprm)  # f[^x[XVK쐬 :SUCCESS, :LOSE, :EXIST
    dbname, dbtype = get_dbname(dbprm)
    if !dbname or !dbtype
      return :LOSE
    end
    if dbprm.class != Hash
      dbprm = {'dbname'=>dbname, 'dbtype'=>dbtype}
    end
    r = :SUCCESS
    conn_str = get_cns(dbprm)
    if conn_str and @conn_str and conn_str.casecmp(@conn_str) == 0
      r = :EXIST
    elsif conn_str and $YadoCreateAdox.include?(dbtype)
      if $YadoLocalType.include?(dbtype) and test(?e, full_path(dbname))
        return :EXIST
      end
      cat = WIN32OLE.new("ADOX.Catalog")
      begin
        cat.Create(conn_str)
      rescue
        @error.stock $!
        r = :LOSE
      ensure
        cat = nil
      end
    elsif !conn_str
      r = :LOSE
    end
    return r
  end

  def drop_db(dbprm)  # DBt@C폜 :SUCCESS, :LOSE
    dbname, dbtype = get_dbname(dbprm)
    if !dbname or !dbtype
      return :LOSE
    end
    conn_str = get_cns({'dbname'=>dbname, 'dbtype'=>dbtype})
    if conn_str and @conn_str and conn_str.casecmp(@conn_str) == 0
      return :LOSE
    end
    r = :SUCCESS
    begin
      File.unlink(full_path(dbname))
    rescue
      @error.stock $!
      r = :LOSE
    end
    return r
  end

  # DBɐڑ true, false
  def open_db(dbprm)
    close_db
    @dbname = @dbtype = @conn_str = nil
    r = false
    dbname, dbtype = get_dbname(dbprm)
    if !dbname
      @error.stock "open_db: f[^x[X擾ł܂."
      return r
    end
    if dbprm.class != Hash
      dbprm = {'dbname'=>dbname, 'dbtype'=>dbtype}
    end
    @dbname, @dbtype = [dbname, dbtype]
    @conn_str = get_cns(dbprm)
    if @conn_str
      @current_conn = WIN32OLE.new("ADODB.Connection")
      begin
        @current_conn.Open @conn_str
        r = true
      rescue
        @error.stock "open_db: '#{@dbname}' " +
            "̃I[vɎs܂.\n" + $!.to_s
        @current_conn = nil
        @conn_str = nil
        @dbtype = nil
        @dbname = nil
      end
    else
      @error.stock "open_db: ڑp擾ł܂."
      @dbname = nil
    end
    return r
  end
  alias :use :open_db
  alias :select_db :open_db

  def close_db()  # DB
    if @current_conn
      @current_conn.Close
      @current_conn = @conn_str = @dbtype = @dbname = nil
    end
  end
  alias :close :close_db

  def list_table_names()  # DB̃e[uꗗ
    res = []
    cat = WIN32OLE.new("ADOX.Catalog")
    cat.ActiveConnection = @current_conn
    cat.Tables.each {|table|
      res << rmquote(table.Name)
    }
    cat = nil
    if @conn_str =~ /excel/i
      ary = []
      res.each {|name|
        ary << name  unless name =~ /\$$/
      }
      ary.each {|name|
        name_d = name + '$'
        res.delete(name_d)  if res.include?(name_d)
      }
    end
    return res
  end

  def list_tables(&block)  # e[üꗗ
    r = []  # ߂l
    if @dbname
      name_list = list_table_names()
      cat = WIN32OLE.new("ADOX.Catalog")
      cat.ActiveConnection = @current_conn
      cat.Tables.each {|table|
        tname = rmquote(table.Name)
        if name_list.include?(tname)
          ts = Table_s.new(tname, table.Type,
              table.DateCreated, table.DateModified)
          r << ts
        end
      }
      cat = nil
    end
    if block
      r.each {|ts|  block.call(ts)}
    end
    return r
  end

  def table_exist(tblname)  # DB̃e[u݊mF true, false
    r = false  # ߂l
    if @dbname
      list = list_table_names()
      if list.include?(tblname)
        r = true
      end
    end
    return r
  end

  def list_fields(tblname, ary_type = :ARRAY, &block)  # tB[h
    r = Array.new
    hf = Hash.new
    if @dbname
      cat = WIN32OLE.new("ADOX.Catalog")
      cat.ActiveConnection = @current_conn
      begin
        table = cat.Tables.Item(tblname)
        table.Columns.each {|column|
          fs = Field_s.new(rmquote(column.Name),
              column.Type, column.DefinedSize,
              column.Precision, column.NumericScale, column.Attributes,
              FldProperties_s.new)
          column.Properties.each {|pr| fs.Properties[pr.Name]=pr.Value}
          hf[rmquote(column.Name)] = fs
        }
        if ary_type == :ARRAY  # `ɃtB[hׂ
          rs = WIN32OLE.new("ADODB.Recordset")
          sql = "SELECT * FROM #{quote(tblname)};"
          rs.Open sql,@current_conn,0,1  # OցAǎp
          for i in 0...rs.Fields.Count
            r << hf[rmquote(rs.Fields.Item(i).Name)]
          end
          rs.Close
          rs = nil
        end
      rescue
        @error.stock "'#{tblname}' ̃tB[h擾" +
            "s܂.\n" + $!.to_s
      ensure
        cat = nil
      end
    end
    if ary_type == :HASH
      hf.each {|key,fs|  block.call(key,fs)}  if block
      return hf
    elsif ary_type == :ARRAY
      r.each {|fs|  block.call(fs)}  if block
      return r
    end
  end

  def field_exist(tblname, fldname)  # e[ũtB[h݊mF
    return defined?(list_fields(tblname, :HASH)[fldname]) ? true : false
  end

  def list_field_names(tblname, binary_sw = :INCLUDE, &block)
    r = []  # ߂l
    rs = WIN32OLE.new("ADODB.Recordset")
    sql = "SELECT * FROM #{quote(tblname)};"
    rs.Open sql,@current_conn,0,1  # OցAǎp
    rs.Fields.each {|fld|
      if Binary_types.include?(fld.Type)  # oCi^̏
        unless binary_sw == :EXCEPT
          r << rmquote(fld.Name)
        end
      else  # oCi^ȊȌ
        unless binary_sw == :ONLY
          r << rmquote(fld.Name)
        end
      end
    }
    rs.Close
    if block
      r.each {|fldname|  block.call(fldname)}
    end
    return r
  end

  def list_field_types(tblname)  # etB[h̃^CvHash
    r = {}
    rs = WIN32OLE.new("ADODB.Recordset")
    sql = "SELECT * FROM #{quote(tblname)};"
    begin
      rs.Open sql,@current_conn,0,1  # OցAǎp
    rescue
      @error.stock "list_field_types: Recordset̃I[v" +
          "Ɏs܂.\n" + $!.to_s
      rs = nil
      return r
    end
    rs.Fields.each {|fld|
      r[rmquote(fld.Name)] = fld.Type
    }
    rs.Close
    return r
  end

  def list_indexes(tblname, &block)  # CfbNX
    r = []  # ߂l
    if @dbname
      cat = WIN32OLE.new("ADOX.Catalog")
      cat.ActiveConnection = @current_conn
      begin
        table = cat.Tables.Item(tblname)
        table.Indexes.each {|idx|
          is = Indexes_s.new(idx.Name, idx.PrimaryKey, idx.Unique,
              idx.IndexNulls, Array.new)
          idx.Columns.each {|col|
            is.Columns << IdxColumns_s.new(col.Name, col.SortOrder)
          }
          r << is
        }
      rescue
        @error.stock "'#{tblname}' ̃CfbNX擾Ɏs܂.\n" + $!.to_s
      ensure
        cat = nil
      end
    end
    if block
      r.each {|is|  block.call(is)}
    end
    return r
  end

  def get_primary_key(tblname, &block)  # Primary Key ̃tB[h
    r = []
    list_indexes(tblname) {|is|
      if is.PrimaryKey == true
        for i in 0...is.Columns.size
          r << is.Columns[i].Name
        end
      end
    }
    if block
      r.each {|n|  block.call(n)}
    end
    return r
  end

  def get_unique(tblname, &block)  # uniquẽtB[h
    r = []
    list_indexes(tblname) {|is|
      next  if is.PrimaryKey == true
      if is.Unique == true
        for i in 0...is.Columns.size
          r << is.Columns[i].Name
        end
      end
    }
    if block
      r.each {|n|  block.call(n)}
    end
    return r
  end

  def result(tblname, fldnames=nil)  # R[h~tB[hResultNX
    res = nil
    if table_exist(tblname) and (!fldnames or fldnames.size > 0)
      tname = quote(tblname)
      fnames = quote(fldnames)
      sql = "SELECT #{fnames} FROM #{tname};"
      rs = WIN32OLE.new("ADODB.Recordset")
      begin
        rs.Open sql,@current_conn,0,1
        res = Result::new(sql)
        res.rs_load(rs, :INCLUDE)
        rs.Close
      rescue
        @error.stock sql + "\n" + $!.to_s
      ensure
        rs = nil
      end
    end
    return res
  end

  def query(sql, &block)  # sql̎sBQzԂ
    if !sql or !@dbname
      return false
    end
    begin
      rs = @current_conn.Execute(sql)
    rescue
      @error.stock sql + "\n" + $!.to_s
      return false
    end
    r = []
    if rs and rs.Fields.Count > 0
      unless rs.EOF or rs.BOF
        rs.MoveFirst
        until rs.EOF
          flds = []
          for i in 0...rs.Fields.Count
            flds << get_value(rs.Fields.Item(i))
          end
          if block
            block.call(flds)
          else
            r << flds
          end
          rs.MoveNext
        end
      end
    end
    return r
  end

  def query_result(sql, binary_sw = :INCLUDE)  # sql̎sBResultNX
    res = nil
    if @dbname
      begin
        rs = @current_conn.Execute(sql)
        res = Result::new(sql)
        res.rs_load(rs, binary_sw)
      rescue
        @error.stock sql + "\n" + $!.to_s
      end
      if res
        if !res.fetch_fields or res.num_rows < 1
          res.free
          res = nil
        end
      end
    end
    return res
  end

  def query_persist(sql, filename)  # sqlsʂsave  :SUCCESS, :LOSE
    res = :LOSE
    if !@dbname
      return res
    end
    ftype = nil
    if filename =~ /\.xml/i
      ftype = 1
    elsif filename =~ /\.adtg/i
      ftype = 0
    end
    if !ftype
      @error.stock sprintf("query_persist: " +
          "t@C '%s' ̊gqsK.", filename)
      return res
    end
    rs = WIN32OLE.new("ADODB.Recordset")
    begin
      rs.Open sql,@current_conn
      if rs.Fields.Count > 0
        rs.Save filename, ftype
        res = :SUCCESS
      end
      rs.Close
    rescue
      @error.stock "query_persist: " + sql + "\n" + $!.to_s
    ensure
      rs = nil
    end
    return res
  end

  def load_persist(filename, tblname=nil)  # Recordset loadBResult | nil
    res = nil
    ftype = nil
    if filename =~ /\.xml$/i
      ftype = 1
    elsif filename =~ /\.adtg$/i
      ftype = 0
    end
    if !ftype
      @error.stock sprintf("R[hZbg̃t@CǍ: " +
          "t@C %s ̊gqsK.", filename)
      return res
    end
    cn = WIN32OLE.new("ADODB.Connection")
    cn.Open "Provider=MSPersist"
    begin
      rs = cn.execute(filename)
      res = Result::new
      res.rs_load(rs, :INCLUDE)
    rescue
      @error.stock "load_persist: " + $!.to_s
    ensure
      cn.Close
      cn = rs = nil
    end
    if res
      if !res.fetch_fields or res.num_rows < 1
        res.free
        res = nil
      end
    end
    if tblname and res
      res.print_to_db(self, tblname)
    end
    return res
  end

  def drop_table(tblname)  # e[u̍폜  true, false
    r = false
    if table_exist(tblname)
      cat = WIN32OLE.new("ADOX.Catalog")
      cat.ActiveConnection = @current_conn
      begin
        cat.Tables.Delete tblname
        r = true
      rescue
        @error.stock $!
      ensure
        cat = nil
      end
    end
    return r
  end

  def insert_records(tblname, aa)
    r = 0
    aa = aa.dup
    aa.delete([])
    if aa.size < 1
      @error.stock "insert_records: e[u #{tblname} - " +
          "}ׂR[h܂."
      return r
    end
    fldnames = checking_field_names(tblname, aa)
    if !fldnames  # PsڂRƂȂ
      @error.stock "insert_records: tB[h̎w肪sKł."
      return r
    end
    hf = list_field_types(tblname)
    for vals in aa
      fn = []
      vals.each_index {|i|
        next  unless fldnames[i]
        next  if vals[i] == nil
        ftype = hf[fldnames[i]]  # tB[h̃f[^^
        if vals[i] =~ /^<<(.+)$/  # t@Cǂݍ
          filename = $1
          fmode = Binary_types.include?(ftype) ? "rb" : "r"
          vals[i] = fread(filename, fmode)
        end
        next  if vals[i] == ''
        fn << fldnames[i]
        if Binary_types.include?(ftype)  # oCȉꍇ
          vals[i] = '0x' + vals[i].unpack("H*")[0]
        elsif [true,false].include?(vals[i]) == false
          vals[i] = "'#{vals[i]}'"  # 'xxx' ň͂
        end
      }
      next  if vals.size < 1
      fdatas = vals.join(',')
      sql = "INSERT INTO #{quote(tblname)} (#{quote(fn)}) " +
          "VALUES(#{fdatas});"
      if query(sql) != false
        r += 1
      else
        break  # G[炻̎_Œf
      end
    end
    return r
  end

  def addnew(tblname, aa)  # f[^ǉ
    r = 0
    aa = aa.dup
    aa.delete([])
    fldnames = checking_field_names(tblname, aa)
    if !fldnames  # PsڂRƂȂ
      @error.stock "addnew: tB[hQ̎w肪sKł."
      return r
    end
    if aa.size < 1
      @error.stock "addnew: e[u #{tblname} - " +
          "}ׂR[h܂."
      return r
    end
    sql = "SELECT #{quote(fldnames)} FROM #{quote(tblname)};"
    rs = WIN32OLE.new("ADODB.Recordset")
    begin
      rs.Open sql,@current_conn,3,3  # RɈړ(user͎̂Qƕs)
    rescue
      @error.stock "addnew:\n" + $!.to_s
      rs = nil
      return r
    end
    for vals in aa
      rs.AddNew
      vals.each_index {|i|
        next  unless fldnames[i]
        next  if vals[i] == nil
        ftype = rs.Fields.Item(fldnames[i]).Type  # f[^^
        if vals[i] =~ /^<<(.+)$/  # t@Cǂݍ
          filename = $1
          fmode = Binary_types.include?(ftype) ? "rb" : "r"
          vals[i] = fread(filename, fmode)
        end
        next  if vals[i] == ''
        if Binary_types.include?(ftype)  # oCȉꍇ
          vals[i] = vals[i].unpack("H*")[0]
        end
        rs.Fields.Item(fldnames[i]).Value = vals[i]
      }
      begin
        rs.Update
      rescue
        @error.stock "addnew: e[u #{tblname}\n" +
            "#{vals.join(',')}\n" + $!.to_s
        rs = nil
        return r
      end
      r += 1
    end
    rs.Close
    rs = nil
    return r
  end

  def update_records(tblname, aa)  # R[h̍XV
    r = [0, 0]
    if table_exist(tblname) == false
      @error.stock 'update_records: Ỹe[u܂.'
      return r
    end
    aa.delete([])
    fldnames = checking_field_names(tblname, aa)
    if !fldnames  # PsڂRƂȂ
      @error.stock "update_records: tB[hQ̎w肪sKł."
      return r
    end
    if aa.size < 1
      @error.stock 'update_records: XVׂR[h܂.'
      return r
    end
    pkname = get_primary_key(tblname) & fldnames
    pki = []  # ɎL[̗vfԍE
    if pkname.size > 0
      pkname.each {|nm|
        pki << fldnames.index(nm)
      }
    else  # L[̎w肪Ȃ
      @error.stock "update_records: Primary Key w肳ĂȂ" +
          "XVs܂."
      return r
    end
    hf = list_fields(tblname, :HASH)
    r[1] = aa.size
    sql = "SELECT #{quote(fldnames)} FROM #{quote(tblname)};"
    rs = WIN32OLE.new("ADODB.Recordset")
    begin
      rs.Open sql,@current_conn,0,3
      flds = Array.new  # eR[h̃tB[hlꎞIɋL^邽߂̕ϐ
      unless rs.EOF or rs.BOF  # R[h݂
        until rs.EOF  # ŏIR[h܂ŌJԂ
          if aa.size < 1  # ͂XVׂf[^Ȃ
            break
          end
          flds.clear  # ڃR[h̃tB[hlɓ
          for fn in fldnames  # tB[ho
            flds << get_value(rs.Fields.Item(fn))
          end
          for i in 0...aa.size  # XVpf[^QƂ̏ƍ
            new_ary = aa[i]
            next  if !new_ary
            if same_array(part_array(flds, pki),  # L[()
                part_array(new_ary, pki))
              for j in 0...fldnames.size  # tB[hƂɏ
                next  if pki.include?(j)  # L[̓XLbv
                ftype = hf[fldnames[j]].Type  # f[^^
                if Binary_types.include?(ftype)  # oCȉꍇ
                  new_ary[j] = new_ary[j].unpack("H*")[0]
                end
                rs.Fields.Item(fldnames[j]).Value = new_ary[j]
              end
              rs.Update
              r[0] += 1
              aa.delete_at i
              break  # uvf[^QƂ̏ƍ[vEp
            end
          end
          rs.MoveNext
        end
      end
      rs.Close
      rs = nil
    rescue
      if new_ary and new_ary.size > 0
        err_s = "update_records: " + new_ary.join("\t") + "\n" + $!.to_s
      else
        err_s = "update_records:\n" + $!.to_s
      end
      @error.stock err_s
    end
    return r
  end

  def update_pair(tblname, aa)  # R[h̍XV
    r = [0, 0]
    if table_exist(tblname) == false
      @error.stock 'update_pair: Ỹe[u܂.'
      return r
    end
    aa.delete([])
    fldnames = checking_field_names(tblname, aa)
    if !fldnames  # PsڂRƂȂ
      @error.stock "update_pair: tB[hQ̎w肪sKł."
      return r
    end
    if aa.size < 2
      @error.stock 'update_pair: VER[h̋Lq܂.'
      return r
    end
    pkname = get_primary_key(tblname) & fldnames
    pki = []  # ɎL[̗vfԍE
    if pkname.size > 0
      pkname.each {|nm|
        pki << fldnames.index(nm)
      }
    end
    hf = list_fields(tblname, :HASH)
    ary = aa.dup
    old_arys = []
    new_arys = []
    while ary.size >= 2  # EVR[h̑gǂݍ
      old_arys << ary.shift
      new_arys << ary.shift
    end
    if old_arys.size != new_arys.size
      @error.stock 'update_pair: R[hƐVR[h̐v܂.'
      return r
    end
    r[1] = old_arys.size  # XV悤Ƃ
    sql = "SELECT #{quote(fldnames)} FROM #{quote(tblname)};"
    rs = WIN32OLE.new("ADODB.Recordset")
    begin
      rs.Open sql,@current_conn,0,3
      flds = Array.new  # eR[h̃tB[hlꎞIɋL^邽߂̕ϐ
      unless rs.EOF or rs.BOF  # R[h݂
        until rs.EOF  # ŏIR[h܂ŌJԂ
          if old_arys.size < 1  # ͂ƍׂ̂Ȃ
            break
          end
          flds.clear  # ڃR[h̃tB[hlɓ
          for fn in fldnames  # tB[ho
            flds << get_value(rs.Fields.Item(fn))
          end
          for i in 0...old_arys.size  # XVpuvf[^QƂ̏ƍ
            old_ary = old_arys[i]
            next  if !old_ary
            if same_array(flds, old_ary)  # v̂
              new_ary = new_arys[i]  # uVvf[^
              for j in 0...fldnames.size  # tB[hƂɏ
                next  if pki.include?(j)  # L[̓XLbv
                ftype = hf[fldnames[j]].Type  # f[^^
                if Binary_types.include?(ftype)  # oCȉꍇ
                  new_ary[j] = new_ary[j].unpack("H*")[0]
                end
                rs.Fields.Item(fldnames[j]).Value = new_ary[j]  # uVv
              end
              rs.Update
              r[0] += 1
              aa.delete_at aa.index(old_arys[i])
              aa.delete_at aa.index(new_arys[i])
              old_arys.delete_at i
              new_arys.delete_at i
              break  # uvf[^QƂ̏ƍ[vEp
            end
          end
          rs.MoveNext
        end
      end
      rs.Close
      rs = nil
    rescue
      if new_ary and new_ary.size > 0
        err_s = "update_pair: " + new_ary.join("\t") + "\n" + $!.to_s
      else
        err_s = "update_pair:\n" + $!.to_s
      end
      @error.stock err_s
    end
    return r
  end

  def update_hash(tblname, fldnames=nil, &block)  # R[h̍XV
    r = 0
    if table_exist(tblname) == false
      @error.stock 'update_hash: Ỹe[u܂.'
      return r
    end
    if fldnames and fldnames.size < 1
      @error.stock 'update_hash: tB[h̎w肪sKł.'
      return r
    end
    unless block
      @error.stock 'update_hash: ubN̋Lq܂.'
      return r
    end
    sql = "SELECT #{quote(fldnames)} FROM #{quote(tblname)};"
    rs = WIN32OLE.new("ADODB.Recordset")
    begin
      rs.Open sql,@current_conn,0,3
      vals = Hash.new
      vals_new = Hash.new
      ary_vals = Array.new
      unless rs.EOF or rs.BOF  # R[h݂
        until rs.EOF  # ŏIR[h܂ŌJԂ
          vals.clear  # ڃR[h̃tB[hlɓ
          ary_vals.clear
          for i in 0...rs.Fields.Count
            ary_vals[i] = get_value(rs.Fields.Item(i))
            vals[rmquote(rs.Fields.Item(i).Name)] = ary_vals[i]
          end
          vals_new.clear
          vals.each {|k,v| vals_new[k]=v}
          block.call(vals_new)
          diff_count = 0
          vals_new.each {|key,val|
            next  if vals_new[key] == nil or vals_new[key] == vals[key]
            diff_count += 1
            if Binary_types.include?(rs.Fields.Item(key).Type)
              val = val.unpack("H*")[0]
            end
            rs.Fields.Item(key).Value = val
          }
          if diff_count > 0
            rs.Update
            r += 1
          end
          rs.MoveNext
        end
      end
      rs.Close
      rs = nil
    rescue
      if ary_vals and ary_vals.size > 0
        err_s = "update_hash: " + ary_vals.join("\t") + "\n" + $!.to_s
      else
        err_s = "update_hash:\n" + $!.to_s
      end
      @error.stock err_s
    end
    return r
  end

  def update_array(tblname, fldnames=nil, &block)  # R[h̍XV
    r = 0
    if table_exist(tblname) == false
      @error.stock 'update_array: Ỹe[u܂.'
      return r
    end
    if fldnames and fldnames.size < 1
      @error.stock 'update_array: tB[h̎w肪sKł.'
      return r
    end
    unless block
      @error.stock 'update_array: ubN̋Lq܂.'
      return r
    end
    sql = "SELECT #{quote(fldnames)} FROM #{quote(tblname)};"
    rs = WIN32OLE.new("ADODB.Recordset")
    begin
      rs.Open sql,@current_conn,0,3
      vals = Array.new
      vals_new = Array.new
      unless rs.EOF or rs.BOF  # R[h݂
        until rs.EOF  # ŏIR[h܂ŌJԂ
          vals.clear  # ڃR[h̃tB[hlɓ
          for i in 0...rs.Fields.Count
            vals[i] = get_value(rs.Fields.Item(i))
          end
          vals_new.clear
          vals.each_index {|i| vals_new[i]=vals[i]}
          block.call(vals_new)
          diff_count = 0
          vals_new.each_index {|i|
            next  if vals_new[i] == nil or vals_new[i] == vals[i]
            diff_count += 1
            if Binary_types.include?(rs.Fields.Item(i).Type)
              vals_new[i] = vals_new[i].unpack("H*")[0]
            end
            rs.Fields.Item(i).Value = vals_new[i]
          }
          if diff_count > 0
            rs.Update
            r += 1
          end
          rs.MoveNext
        end
      end
      rs.Close
      rs = nil
    rescue
      if vals_new and vals_new.size > 0
        err_s = "update_array: " + vals_new.join("\t") + "\n" + $!.to_s
      else
        err_s = "update_array:\n" + $!.to_s
      end
      @error.stock err_s
    end
    return r
  end

  def delete_records(tblname, aa)  # R[h̍폜
    r = [0, 0]
    if table_exist(tblname) == false
      @error.stock 'delete_records: Ỹe[u܂.'
      return r
    end
    aa.delete([])
    fldnames = checking_field_names(tblname, aa)
    if !fldnames  # PsڂRƂȂ
      @error.stock "delete_records: tB[hQ̎w肪sKł."
      return r
    end
    if aa.size < 1
      @error.stock 'delete_records: 폜ׂR[h܂.'
      return r
    end
    hf = list_fields(tblname, :HASH)
    r[1] = aa.size
    sql = "SELECT #{quote(fldnames)} FROM #{quote(tblname)};"
    rs = WIN32OLE.new("ADODB.Recordset")
    begin
      rs.Open sql,@current_conn,3,3
      flds = Array.new  # eR[h̃tB[hlꎞIɋL^邽߂̕ϐ
      unless rs.EOF or rs.BOF  # R[h݂
        rs.MoveFirst  # ŏ̃R[hɈړ
        until rs.EOF  # ŏIR[h܂ŌJԂ
          if aa.size < 1  # ͂ƍׂ̂Ȃ
            break
          end
          flds.clear  # ڃR[h̃tB[hlɓ
          for fn in fldnames  # tB[ho
            flds << get_value(rs.Fields.Item(fn))
          end
          for i in 0...aa.size  # 폜pf[^Ƃ̏ƍ
            match_ary = aa[i]
            next  if !match_ary
            if same_array(flds, match_ary)  # v̂
              rs.Delete
              r[0] += 1
              aa.delete_at i
              break
            end
          end
          rs.MoveNext
        end
      end
      rs.Close
      rs = nil
    rescue
      if match_ary and match_ary.size > 0
        err_s = "delete_records: " + match_ary.join("\t") + "\n" + $!.to_s
      else
        err_s = "delete_records:\n" + $!.to_s
      end
      @error.stock err_s
    end
    return r
  end

  def create_table_sql(tblname)
    k = get_primary_key(tblname)
    k = []  if k.size > 1
    u = get_unique(tblname)
    flds = []
    list_fields(tblname) {|fs|
      a = field_form_sql(fs)  # a[0]:tB[hAa[1]:f[^^
      ai = a.size-1
      if k.size > 0 and k.include?(a[0])  # L[ł
        if ai < 2
          a << "PRIMARY KEY"
        else
          a[ai] = "PRIMARY KEY " + a[ai]
        end
      elsif u.size > 0 and u.include?(a[0])  # Uniqueł
        if ai < 2
          a << "UNIQUE"
        else
          a[ai] = "UNIQUE " + a[ai]
        end
      end
      w = "#{quote(a[0])} #{a[1]}"
      w += " #{a[2]}"  if a.size > 2
      flds << w
    }
    sql = (flds.size < 1) ? nil :
        "CREATE TABLE #{quote(tblname)} (#{flds.join(',')});"
    return sql
  end

  def ado_version
    cn = WIN32OLE.new("ADODB.Connection")
    r = cn.Version
    cn = nil
    return r
  end

  #---- ȍ~́ANX private method
  def checking_field_names(tblname, aa)  # zaa1sڂfield̔
    if aa.size < 1
      return nil
    end
    org_fldnames = list_field_names(tblname)
    fldnames = aa[0]
    w = org_fldnames & fldnames
    if w.size == fldnames.size  # tB[hƔF߂
      aa.shift
      fldnames.map! {|i|
        i = rm_both_space(i)
        i = rm_unable_char(i)
      }
    elsif w.size == 0  # tB[hł͂Ȃ
      fldnames = org_fldnames
    else  # PsڂRƂȂ
      fldnames = nil
    end
    return fldnames
  end
  private :checking_field_names

  def get_dbname(prm)
    dbname = dbtype = nil
    if prm.class == Hash
      dbname = prm['dbname']
      if dbname.class != String
        return [nil, nil]
      end
      dbtype = prm['dbtype']
      unless dbtype
        ext = File.extname(dbname).downcase
        ext = ext.sub(/^\./, "")
        dbtype = ext.intern
      end
    elsif prm.class == String
      dbname = prm.dup
      ext = File.extname(dbname).downcase
      ext = ext.sub(/^\./, "")
      dbtype = ext.intern
    end
    if dbtype and !$YadoCns[dbtype] and $YadoTypeReplace[dbtype]
      dbtype = $YadoTypeReplace[dbtype]
    end
    if !dbname or !dbtype or !$YadoCns[dbtype]
      dbname = dbtype = nil
    end
    return [dbname, dbtype]
  end
  private :get_dbname

  def get_cns(hs)
    dbname, dbtype = get_dbname(hs)
    if !dbname or !dbtype
      return nil
    end
    if hs.class != Hash
      hs = {'dbname'=>dbname, 'dbtype'=>dbtype}
    else
      hs = hs.dup
    end
    cns = $YadoCns[dbtype].dup
    if hs['dbname'] and cns =~ /%dbname%/ and $YadoLocalType.include?(dbtype)
        hs['dbname'] = full_path(hs['dbname'])
    end
    if cns =~ /%hdr%/ and !hs['hdr']
      hs['hdr'] = 'Yes'
    end
    hs.each {|key, val|
      rg = /%#{key}%/
      if cns =~ rg
        cns = cns.sub(rg, val)
      end
    }
    while cns =~ /%(.+?)%/
      key = $1
      cns = cns.sub(/[^;]+%#{key}%;?/, "")
    end
    return cns
  end
  private :get_cns
end


# ADO | ADOX ȒPɈ߂̉pNX
class Yado < Yadobase
  include YadoCsvTab
  include YadoBin

  def print_all_values(filename, target=nil)
    if filename =~ /\.xlsx?/i
      print_to_xls(filename, target)
      return
    end
    target = ['TABLE']  if target == nil
    if target.class != Array
      target = target.to_a
    end
    tbltype = target & TABLE_type
    r = []
    list_tables()   {|ts|
      if tbltype.size > 0  # Lȃe[uނ̎w肪
        unless tbltype.include?(ts.Type) # w̃e[uނɃ}b`Ȃ
          next
        end
      else  # e[u̎ނ̎w͂ȂO̎wƂ݂Ȃ
        unless target.include?(ts.Name)  # w̃e[uɃ}b`Ȃ
          next
        end
      end
      tname = ts.Name.dup
      fldnames = list_field_names(tname, :EXCEPT)
      r << [tname]
      r << fldnames
      result(tname, fldnames).each {|fldvals|
        r << fldvals
      }
      r << []
    }
    print_array(filename, r)
  end
  alias :pav :print_all_values

  def print_to_xls(filename, target=nil)
    target = ['TABLE']  if target == nil
    if target.class != Array
      target = target.to_a
    end
    tbltype = target & TABLE_type
    flds = Array.new
    fldnames = Array.new
    if filename =~ /\.xlsx$/i
      conn_str = "Provider=Microsoft.ACE.OLEDB.12.0;" +
          "Data Source=#{full_path(filename)};" +
          "Extended Properties=\"Excel 12.0 XML;HDR=Yes;\""
    else
      conn_str = "Provider=Microsoft.Jet.OLEDB.4.0;" +
          "Data Source=#{full_path(filename)};" +
          "Extended Properties=\"Excel 8.0;HDR=Yes;\""
    end
    cn = WIN32OLE.new("ADODB.Connection")
    cn.Open conn_str
    list_tables() {|ts|
      if tbltype.size > 0  # Lȃe[uނ̎w肪
        unless tbltype.include?(ts.Type) # w̃e[uނɃ}b`Ȃ
          next
        end
      else  # e[u̎ނ̎w͂ȂO̎wƂ݂Ȃ
        unless target.include?(ts.Name)  # w̃e[uɃ}b`Ȃ
          next
        end
      end
      tname = ts.Name.dup
      if @conn_str =~ /excel/i and tname =~ /\$$/
        tname = tname.sub(/\$$/, "")
      end
      flds.clear
      fldnames.clear
      list_fields(ts.Name) {|fs|
        a = field_form_sql(fs)  # a[0]:tB[hAa[1]:f[^^
        if a[1] =~ /binary/i  # oCi^̓XLbv
          next
        elsif a[1] =~ /counter/i  # I[gCNg^ integer 
          a[1] = 'integer'
        elsif a[1] =~ /\(.+\)/  # w͍폜
          a[1] = a[1].sub(/\(.+\)/, "")
        end
        flds << "#{quote(a[0])} #{a[1]}"  # tB[h Name, Type L^
        fldnames << a[0]  # tB[h Name L^
      }
      next  if fldnames.size < 1
      datas = []
      result(ts.Name, fldnames).each {|rs|  datas<<rs}  # R[hL^
      if datas.size == 0
        @error.stock "#{File.basename(@dbname)}̃e[u #{tname}" +
            "ł. oXLbv܂."
        next
      end
      create_xls(cn, tname, flds, fldnames, datas)
    }
    cn.Close
  end
  alias :p2x :print_to_xls

  def print_binary_values(tblname, bin_name=nil, ext='.bin')
    if table_exist(tblname)
      binary_names = list_field_names(tblname, :ONLY)
      return  if binary_names.size < 1  # oCi[^Ȃ
      if bin_name and binary_names.include?(bin_name) == false
        return  # w肳ꂽ̂̓oCi[łȂߒf
      elsif bin_name
        binary_names = [bin_name]  # w̃tB[hΏۂ
      else  # if !bin_name
        bin_name = binary_names[0]  # ō̃oCî݂Ώۂ
      end
      fldnames = list_field_names(tblname, :EXCEPT)[0..1]
      result(tblname, fldnames+[bin_name]).each {|fldval|
        bin_body = fldval.pop
        wbmp = get_native_bmp(bin_body)
        if wbmp  # BMP𒊏oł
          bin_body = wbmp
          ext = '.bmp'
        end
        dbname_base = tblname + '_' + fldval.join('_')
        dbname_base = dbname_base.gsub(/[\*\?\|<>\"]+/, "")
        fname = dbname_base + ext
        File.open(fname, "wb") {|file|  file.write(bin_body)}
      }
    end
  end
  alias :pbv :print_binary_values

  def get_field_info(ts, output_type = :SQL)
    r = []
    k = get_primary_key(ts.Name)
    u = get_unique(ts.Name)
    r << [ts.Name, ts.Type, ts.DateCreated, ts.DateModified]
    list_fields(ts.Name) {|fs|
      if output_type == :MS
        a = field_form_ms(fs)
      else
        a = field_form_sql(fs)
      end
      if k.size > 0 and k.include?(a[0])  # L[ł
        a[0] = '!' + a[0]
      end
      if u.size > 0 and u.include?(a[0])  # Uniqueł
        if fs.Properties["Nullable"] == false or
           fs.Properties["Default"].to_s != ''
          j = a.size-1
          a[j] = 'Unique ' + a[j]
        else  # ɃIvV͂Ȃ
          a << 'Unique'
        end
      end
      r << a
    }
    return r
  end

  def print_field_info(filename, output_type = :SQL, target=nil)
    r = []
    target = ['TABLE']  if target == nil
    if target.class != Array
      target = target.to_a
    end
    tbltype = target & TABLE_type
    list_tables() {|ts|
      if tbltype.size > 0  # Lȃe[uނ̎w肪
        unless tbltype.include?(ts.Type) # w̃e[uނɃ}b`Ȃ
          next
        end
      else  # e[u̎ނ̎w͂ȂO̎wƂ݂Ȃ
        unless target.include?(ts.Name)  # w̃e[uɃ}b`Ȃ
          next
        end
      end
      w = get_field_info(ts, output_type)
      if w.size > 0
        while a = w.shift
          r << a
        end
        r << []
      end
    }
    print_array(filename, r)
  end
  alias :pfi :print_field_info

  def print_to_db(db)
    r = 0
    list_tables() {|ts|
      next  unless ts.Type == 'TABLE'
      tblname = ts.Name
      unless db.query( create_table_sql(tblname) )
        next
      end
      sql = "select * from #{quote(tblname)};"
      datas = self.query(sql)
      if datas and datas.size > 0
        db.addnew(tblname, datas)
        r += 1
      end
    }
    return r
  end
  alias :p2d :print_to_db
end    # Yado ܂

include YadoCsvTab
include YadoBin
