# yados.rb on yado.rb v1.6  (coding: Windows-31J) 2012/07/04
  # Copyright (C) T. Yoshiizumi, 2012 All rights reserved.
  # renew some methods of Yado class, in order to handle sqlite3
  # tested on sqlite odbc driver version 0.95 for Win32
  # reference: SQLite ODBC Driver (http://www.ch-werner.de/sqliteodbc/)
require 'yado'

# ADO̐ڑpȂ̒`ǉ
  $YadoCns[:sqlite] = "Provider=MSDASQL;Driver={SQLite3 ODBC Driver};" +
      "Database=%dbname%"
  $YadoLocalType << :sqlite
  $YadoTypeReplace[:db] = :sqlite  # test.dbȂǂsqlite3t@CƂ݂Ȃ

# Yadõ\bhĒ`
class Yados < Yado
  def sqlite_fields(ts)
    tblname = ts[1]
    fldnames = list_field_names(tblname)
    fldnames.map! {|x|
      x = x.gsub(/\s+/, " ")
    }
    str = ts[4]
    str = str.gsub(/\s+/, " ")
    str = str.sub(/^ +/, "").sub(/ +$/, "")
    str = str.gsub(/"([^"]+)"/, "[\\1]")
    str = str.gsub(/['`]([^'`]+)['`]/, "[\\1]")
    flds = []
    if str =~ /create table .+?\((.+)\)/i
      d = $1
      d = d.gsub(/\([^\)]+\)/, "")
      flds = d.split(/,/)
      flds.map! {|x|
        x = x.sub(/^ +/, "")
        x = x.sub(/ +$/, "")
      }
    end
    hf = {}
    if flds.size == fldnames.size
      for i in 0...flds.size
        w = flds[i].index(fldnames[i])
        if w != 0 and w != 1
          hf = {}
          break
        end
        hf[fldnames[i]] = flds[i]
      end
    end
    return hf
  end
  private :sqlite_fields

  def list_tables(&block)
    if @dbtype == :sqlite
      r = []
      ary = query( "select * from sqlite_master;" )
      unless ary
        return r
      end
      ary.each {|ts|
        next  if ts[0] =~ /^index$/i
        next  if ts[1] =~ /^sqlite_sequence$/i
        r << ts
      }
      if block
        r.each {|ts|  block.call(ts)}
      end
      return r
    else
      super(&block)
    end
  end

  def list_table_names()
    if @dbtype == :sqlite
      r = []
      ary = query( "select * from sqlite_master;" )
      unless ary
        return r
      end
      ary.each {|ts|
        next  if ts[0] =~ /^index$/i
        next  if ts[1] =~ /^sqlite_sequence$/i
        r << ts[1]
      }
      return r
    else
      super
    end
  end

  def list_fields(tblname, ary_type = :ARRAY, &block)
    r = Array.new
    hf = Hash.new
    if @dbtype == :sqlite
      rs = WIN32OLE.new("ADODB.Recordset")
      sql = "SELECT * FROM #{quote(tblname)};"
      begin
        rs.Open sql,@current_conn,0,1  # OցAǎp
      rescue
        @error.stock "'#{tblname}' ̃tB[h擾" +
            "s܂.\n" + $!.to_s
        rs = nil
      end
      if rs
        rs.Fields.each {|fld|
          fldname = rmquote(fld.Name)
          fs = Field_s.new(fldname,
              fld.Type, fld.DefinedSize,
              fld.Precision, fld.NumericScale, fld.Attributes,
              FldProperties_s.new)
          hf[fldname] = fs
          r << fs
        }
        rs.Close
        rs = nil
      end
      if ary_type == :HASH
        hf.each {|key,fs|  block.call(key,fs)}  if block
        return hf
      else
        r.each {|fs|  block.call(fs)}  if block
        return r
      end
    else
      super(tblname, ary_type, &block)
    end
  end

  def list_indexes(tblname, &block)
    if @dbtype == :sqlite
      return []
    else
      super(tblname, &block)
    end
  end

  def print_to_db(db)
    if @dbtype == :sqlite
      r = 0
      ary = list_tables()
      ary.each {|ts|
        tblname = ts[1]
        sql = ts[4]
        if [:mdb, :accdb].include?(db.db_type)
          sql = sql.sub(/integer([^,]*?) +autoincrement/i, "counter\\1")
        end
        unless db.query( sql )
          next
        end
        sql = "select * from [#{tblname}];"
        datas = query(sql)
        if datas and datas.size > 0
          db.addnew(tblname, datas)
          r += 1
        end
      }
      return r
    end
    super(db)
  end
  alias :p2d :print_to_db

  def print_to_xls(filename, target=nil)
    if @dbtype == :sqlite
      r = 0
      target = ['table']  if target == nil
      if target.class != Array
        target = target.to_a
      end
      tbltype = target & ['TABLE', 'VIEW']
      ary = list_tables()
      ary.each {|ts|
        if tbltype.size > 0  # Lȃe[uނ̎w肪
          unless tbltype.include?(ts[0].upcase) # w̃e[uނɃ}b`Ȃ
            next
          end
        else  # e[u̎ނ̎w͂ȂO̎wƂ݂Ȃ
          unless target.include?(ts[1])  # w̃e[uɃ}b`Ȃ
            next
          end
        end
        tblname = ts[1]
        fldnames = list_field_names(tblname, :EXCEPT)
        next  if fldnames.size < 1
        sql = "select #{quote(fldnames)} from #{quote(tblname)};"
        res = query_result(sql)
        next  unless res
        res.print_to_xls(filename, tblname)
        r += 1
      }
      return r
    end
    super(filename, target)
  end
  alias :p2x :print_to_xls

  def print_all_values(filename, target=nil)
    if @dbtype == :sqlite
      if filename =~ /\.xlsx?/i
        print_to_xls(filename, target)
        return
      end
      r = []
      target = ['table']  if target == nil
      if target.class != Array
        target = target.to_a
      end
      tbltype = target & ['TABLE', 'VIEW']
      ary = list_tables()
      ary.each {|ts|
        if tbltype.size > 0  # Lȃe[uނ̎w肪
          unless tbltype.include?(ts[0].upcase) # w̃e[uނɃ}b`Ȃ
            next
          end
        else  # e[u̎ނ̎w͂ȂO̎wƂ݂Ȃ
          unless target.include?(ts[1])  # w̃e[uɃ}b`Ȃ
            next
          end
        end
        tblname = ts[1]
        fldnames = list_field_names(tblname, :EXCEPT)
        next  if fldnames.size < 1
        sql = "select #{quote(fldnames)} from #{quote(tblname)};"
        datas = query(sql)
        next  if !datas or datas.size < 1
        r << [tblname]
        r << fldnames
        r += datas
        r << []
      }
      print_array(filename, r)
    else
      super(filename, target)
    end
  end
  alias :pav :print_all_values

  def get_primary_key(tblname, &block)
    if @dbtype == :sqlite
      r = []
      list_tables() {|ts|
        next  unless ts[1] == tblname
        hf = sqlite_fields(ts)
        list_field_names(tblname) {|x|
          x2 = x.gsub(/\s+/, " ")
          if hf[x2] =~ / primary key | primary key$/i
            r << x
          end
        }
      }
      if block
        r.each {|n|  block.call(n)}
      end
      return r
    else
      super(tblname, &block)
    end
  end

  def get_unique(tblname, &block)
    if @dbtype == :sqlite
      r = []
      list_tables() {|ts|
        next  unless ts[1] == tblname
        hf = sqlite_fields(ts)
        list_field_names(tblname) {|x|
          x2 = x.gsub(/\s+/, " ")
          if hf[x2] =~ / unique | unique$/i
            r << x
          end
        }
      }
      if block
        r.each {|n|  block.call(n)}
      end
      return r
    else
      super(tblname, &block)
    end
  end

  def get_field_info(ts, output_type = :SQL)
    if @dbtype == :sqlite
      r = []
      k = get_primary_key(ts[1])
      u = get_unique(ts[1])
      r << [ts[1], ts[0].upcase, nil, nil]
      list_fields(ts[1]) {|fs|
        if output_type == :MS
          a = field_form_ms(fs)
        else
          a = field_form_sql(fs)
        end
        if k.size > 0 and k.include?(a[0])  # L[ł
          a[0] = '!' + a[0]
        end
        if u.size > 0 and u.include?(a[0])  # Uniqueł
          if fs.Properties["Nullable"] == false or
             fs.Properties["Default"].to_s != ''
            j = a.size-1
            a[j] = 'Unique ' + a[j]
          else  # ɃIvV͂Ȃ
            a << 'Unique'
          end
        end
        r << a
      }
      return r
    else
      super(ts, output_type)
    end
  end

  def print_field_info(filename, output_type = :SQL, target=nil)
    if @dbtype == :sqlite
      r = []
      target = ['TABLE']  if target == nil
      if target.class != Array
        target = target.to_a
      end
      tbltype = target & TABLE_type
      list_tables() {|ts|
        if tbltype.size > 0  # Lȃe[uނ̎w肪
          unless tbltype.include?(ts[0].upcase) # w̃e[uނɃ}b`Ȃ
            next
          end
        else  # e[u̎ނ̎w͂ȂO̎wƂ݂Ȃ
          unless target.include?(ts[1])  # w̃e[uɃ}b`Ȃ
            next
          end
        end
        w = get_field_info(ts, output_type)
        if w.size > 0
          while a = w.shift
            r << a
          end
          r << []
        end
      }
      print_array(filename, r)
    else
      super(filename, output_type, target)
    end
  end
  alias :pfi :print_field_info
end
